/*
** fireup_handler.c
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2.1 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <nokix/all.h>
#include "global.h"

#define OMSG_CHECK_MENU    (0x1e03)

static unsigned char key;

extern unsigned char menu_level1_opened;

/**************************************************************************************/

/* UI messages dispatcher */
extern rexx_uint fireup_handler_id; /* dispatcher's call id */
rexx("fireup_handler_id=add_5e0_id(fireup_handler)"); /* auto creation of the id */

unsigned fireup_handler(unsigned msg)
{
   switch(msg)
   {
      case MSG_D_INIT:
         key=msg_argv[1]; /* we save it in global var to access it later */

         upper_mode(UPM_MENU); /* this hides clock and net/batt bars */

         send_message(shortkeys[key].msg|MSG_1P,shortkeys[key].arg);
         if(shortkeys[key].flags&MIF_SEND_SHORTCUT_INFO)
            send_message(MSG_MENU_SHORTCUT_INFO|MSG_2P,shortkeys[key].arg,0);

         msg=MSG_R_STAY;
         break;

      case MSG_D_QUIT:
         msg=MSG_R_QUIT;
         break;

      case MSG_D_QUIT_NOW:
         if(shortkeys[key].msg!=MSG_START_HANDLER)
         {
            menu_reopen();
            msg=MSG_R_STAY;
         }
         break;
         
      case MSG_SELECT:
         if(shortkeys[key].msg!=MSG_START_HANDLER)
            send_message(OMSG_CHECK_MENU|MSG_1P,1);
         break;
         
      case OMSG_CHECK_MENU:
         if(msg_argv[0]<4) send_message(OMSG_CHECK_MENU|MSG_1P,msg_argv[0]+1);
         else
         {
            if(!menu_level1_opened) send_message(MSG_REQUEST_QUIT_OK);
         }
         msg=MSG_NOP;
         break;
   }
   return msg;
}

